/* box.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
int InsideBox(ObjectStruct *Box, double x, double y, double z);
int FindIntersectionBoxSegment(Vector InterPoint, Vector InterNorm,
                               Vector InPoint, Vector OutPoint,
                               ObjectStruct *Box);
void ComputeBoxTriangleMesh(ObjectStruct *Box);
void TranslateBox(ObjectStruct *Box, Vector Vect);
void RotateBox(ObjectStruct *Box, Vector Vect);
void ScaleBox(ObjectStruct *Box, Vector Vect);
int IsBoxIntersection(ObjectStruct *Box, Vector Origin, Vector Direction);
int ClickInBoxXY(ObjectStruct *Box, gdouble x, gdouble y);
int ClickInBoxXZ(ObjectStruct *Box, gdouble x, gdouble y);
int ClickInBoxZY(ObjectStruct *Box, gdouble x, gdouble y);
void ToolInitNewBox(GtkWidget *DrawingArea, GdkEventButton *bevent);
void ToolMotionNewBox(GtkWidget *DrawingArea, GdkEvent *event);
void ToolReleaseNewBox(GtkWidget *DrawingArea, GdkEvent *event);
int PDBCreateBox(int *Id, Vector *MinCoord, Vector *MaxCoord);
