/* cone.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
/* Global options for the cone tool */
extern int ConeFunnelFlag;

int InsideCone(ObjectStruct *Cone, double x, double y, double z);
int FindIntersectionConeSegment(Vector InterPoint, Vector InterNorm,
                                Vector InPoint, Vector OutPoint,
                                ObjectStruct *Cone);
void ComputeConeTriangleMesh(ObjectStruct *Cone);
void TranslateCone(ObjectStruct *Cone, Vector Vect);
void RotateCone(ObjectStruct *Cone, Vector Vect);
void ScaleCone(ObjectStruct *Cone, Vector Vect);
int IsConeIntersection(ObjectStruct *Cone, Vector Origin, Vector Direction);
int ClickInConeXY(ObjectStruct *Cone, gdouble x, gdouble y);
int ClickInConeXZ(ObjectStruct *Cone, gdouble x, gdouble y);
int ClickInConeZY(ObjectStruct *Cone, gdouble x, gdouble y);
void ToolInitNewCone(GtkWidget *DrawingArea, GdkEventButton *bevent);
void ToolMotionNewCone(GtkWidget *DrawingArea, GdkEvent *event);
void ToolReleaseNewCone(GtkWidget *DrawingArea, GdkEvent *event);
GtkWidget *BuildConeOptions(GtkWidget *VBox);
ObjectStruct *CreateCone(Vector Base, double BaseRadius,
                         Vector Apex, double ApexRadius);
int PDBCreateCone(int *Id, Vector *Base, double *BaseRadius,
                           Vector *Apex, double *ApexRadius);

