/* cylinder.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
int InsideCylinder(ObjectStruct *Cylinder, double x, double y, double z);
int FindIntersectionCylinderSegment(Vector InterPoint, Vector InterNorm,
                                    Vector InPoint, Vector OutPoint,
                                    ObjectStruct *Cylinder);
void ComputeCylinderTriangleMesh(ObjectStruct *Cylinder);
void TranslateCylinder(ObjectStruct *Cylinder, Vector Vect);
void RotateCylinder(ObjectStruct *Cylinder, Vector Vect);
void ScaleCylinder(ObjectStruct *Cylinder, Vector Vect);
int IsCylinderIntersection(ObjectStruct *Cylinder, Vector Origin, Vector Direction);
int ClickInCylinderXY(ObjectStruct *Cylinder, gdouble x, gdouble y);
int ClickInCylinderXZ(ObjectStruct *Cylinder, gdouble x, gdouble y);
int ClickInCylinderZY(ObjectStruct *Cylinder, gdouble x, gdouble y);
void ToolInitNewCylinder(GtkWidget *DrawingArea, GdkEventButton *bevent);
void ToolMotionNewCylinder(GtkWidget *DrawingArea, GdkEvent *event);
void ToolReleaseNewCylinder(GtkWidget *DrawingArea, GdkEvent *event);
GtkWidget *BuildCylinderOptions(GtkWidget *VBox);
ObjectStruct *CreateCylinder(Vector Base, Vector Apex, double Radius);
int PDBCreateCylinder(int *Id, Vector *Base, Vector *Apex, double *Radius);

