/* disc.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Global options for the disc tool */
extern int DiscWithHoleFlag;

int InsideDisc(ObjectStruct *Disc, double x, double y, double z);
int FindIntersectionDiscSegment(Vector InterPoint, Vector InterNorm,
                                Vector InPoint, Vector OutPoint,
                                ObjectStruct *Disc);
void ComputeDiscTriangleMesh(ObjectStruct *Disc);
void TranslateDisc(ObjectStruct *Disc, Vector Vect);
void RotateDisc(ObjectStruct *Disc, Vector Vect);
void ScaleDisc(ObjectStruct *Disc, Vector Vect);
int IsDiscIntersection(ObjectStruct *Disc, Vector Origin, Vector Direction);
int ClickInDiscXY(ObjectStruct *Disc, gdouble x, gdouble y);
int ClickInDiscXZ(ObjectStruct *Disc, gdouble x, gdouble y);
int ClickInDiscZY(ObjectStruct *Disc, gdouble x, gdouble y);
void ToolInitNewDisc(GtkWidget *DrawingArea, GdkEventButton *bevent);
void ToolMotionNewDisc(GtkWidget *DrawingArea, GdkEvent *event);
void ToolReleaseNewDisc(GtkWidget *DrawingArea, GdkEvent *event);
GtkWidget *BuildDiscOptions(GtkWidget *VBox);
int PDBCreateDisc(int *Id, Vector *Center, Vector *Normal,
                  double *Radius, double *HoleRadius);
