/* height_field.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
int InsideHeightField(ObjectStruct *HeightField, double x, double y, double z);
int FindIntersectionHeightFieldSegment(Vector InterPoint, Vector InterNorm,
                                       Vector InPoint, Vector OutPoint,
                                       ObjectStruct *HeightField);
void ComputeHeightFieldTriangleMesh(ObjectStruct *HeightField);
void TranslateHeightField(ObjectStruct *HeightField, Vector Vect);
void RotateHeightField(ObjectStruct *HeightField, Vector Vect);
void ScaleHeightField(ObjectStruct *HeightField, Vector Vect);
int IsHeightFieldIntersection(ObjectStruct *HeightField, Vector Origin, Vector Direction);
int ClickInHeightFieldXY(ObjectStruct *HeightField, gdouble x, gdouble y);
int ClickInHeightFieldXZ(ObjectStruct *HeightField, gdouble x, gdouble y);
int ClickInHeightFieldZY(ObjectStruct *HeightField, gdouble x, gdouble y);
void ToolNewHeightField(GtkWidget *DrawingArea, GdkEventButton *bevent);

