/* polygon.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
int InsidePolygon(ObjectStruct *Polygon, double x, double y, double z);
int FindIntersectionPolygonSegment(Vector InterPoint, Vector InterNorm,
                                   Vector InPoint, Vector OutPoint,
                                   ObjectStruct *Polygon);
void ComputePolygonTriangleMesh(ObjectStruct *Polygon);
void TranslatePolygon(ObjectStruct *Polygon, Vector Vect);
void RotatePolygon(ObjectStruct *Polygon, Vector Vect);
void ScalePolygon(ObjectStruct *Polygon, Vector Vect);
int IsPolygonIntersection(ObjectStruct *Polygon, Vector Origin, Vector Direction);
int ClickInPolygonXY(ObjectStruct *Polygon, gdouble x, gdouble y);
int ClickInPolygonXZ(ObjectStruct *Polygon, gdouble x, gdouble y);
int ClickInPolygonZY(ObjectStruct *Polygon, gdouble x, gdouble y);
void ToolNewPolygon(GtkWidget *DrawingArea, GdkEventButton *bevent);

