/* quadric.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
int InsideQuadric(ObjectStruct *Quadric, double x, double y, double z);
int FindIntersectionQuadricSegment(Vector InterPoint, Vector InterNorm,
                                   Vector InPoint, Vector OutPoint,
                                   ObjectStruct *Quadric);
void ComputeQuadricTriangleMesh(ObjectStruct *Quadric);
void TranslateQuadric(ObjectStruct *Quadric, Vector Vect);
void RotateQuadric(ObjectStruct *Quadric, Vector Vect);
void ScaleQuadric(ObjectStruct *Quadric, Vector Vect);
int IsQuadricIntersection(ObjectStruct *Quadric, Vector Origin, Vector Direction);
int ClickInQuadricXY(ObjectStruct *Quadric, gdouble x, gdouble y);
int ClickInQuadricXZ(ObjectStruct *Quadric, gdouble x, gdouble y);
int ClickInQuadricZY(ObjectStruct *Quadric, gdouble x, gdouble y);
void ToolNewQuadric(GtkWidget *DrawingArea, GdkEventButton *bevent);

