/* sphere.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

int InsideSphere(ObjectStruct *Sphere, double x, double y, double z);
void ComputeSphereTriangleMesh(ObjectStruct *Sphere);
int FindIntersectionSphereSegment(Vector InterPoint, Vector InterNorm,
                                  Vector InPoint, Vector OutPoint,
                                  ObjectStruct *Object);
void TranslateSphere(ObjectStruct *Sphere, Vector Vect);
void RotateSphere(ObjectStruct *Sphere, Vector Vect);
void ScaleSphere(ObjectStruct *Sphere, Vector Vect);
int IsSphereIntersection(ObjectStruct *Sphere, Vector Origin, Vector Direction);
int ClickInSphereXY(ObjectStruct *Sphere, gdouble x, gdouble y);
int ClickInSphereXZ(ObjectStruct *Sphere, gdouble x, gdouble y);
int ClickInSphereZY(ObjectStruct *Sphere, gdouble x, gdouble y);
void ToolInitNewSphere(GtkWidget *DrawingArea, GdkEventButton *bevent);
void ToolMotionNewSphere(GtkWidget *DrawingArea, GdkEvent *event);
void ToolReleaseNewSphere(GtkWidget *DrawingArea, GdkEvent *event);
ObjectStruct *CreateSphere(Vector Center, double Radius);
int PDBCreateSphere(int *Id, Vector *Center, double *Radius);

