/* superellipsoid.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
int InsideSuperEllipsoid(ObjectStruct *SuperEllipsoid, double x, double y, double z);
int FindIntersectionSuperEllipsoidSegment(Vector InterPoint, Vector InterNorm,
                                          Vector InPoint, Vector OutPoint,
                                          ObjectStruct *SuperEllipsoid);
void ComputeSuperEllipsoidTriangleMesh(ObjectStruct *SuperEllipsoid);
void TranslateSuperEllipsoid(ObjectStruct *SuperEllipsoid, Vector Vect);
void RotateSuperEllipsoid(ObjectStruct *SuperEllipsoid, Vector Vect);
void ScaleSuperEllipsoid(ObjectStruct *SuperEllipsoid, Vector Vect);
int IsSuperEllipsoidIntersection(ObjectStruct *SuperEllipsoid, Vector Origin, Vector Direction);
int ClickInSuperEllipsoidXY(ObjectStruct *SuperEllipsoid, gdouble x, gdouble y);
int ClickInSuperEllipsoidXZ(ObjectStruct *SuperEllipsoid, gdouble x, gdouble y);
int ClickInSuperEllipsoidZY(ObjectStruct *SuperEllipsoid, gdouble x, gdouble y);
void ToolNewSuperEllipsoid(GtkWidget *DrawingArea, GdkEventButton *bevent);
int PDBCreateSuperEllipsoid(int *Id, double *N, double *E);
