/* triangle.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
int InsideTriangle(ObjectStruct *Triangle, double x, double y, double z);
int FindIntersectionTriangleSegment(Vector InterPoint, Vector InterNorm,
                                    Vector InPoint, Vector OutPoint,
                                    ObjectStruct *Triangle);
void ComputeTriangleTriangleMesh(ObjectStruct *Triangle);
void TranslateTriangle(ObjectStruct *Triangle, Vector Vect);
void RotateTriangle(ObjectStruct *Triangle, Vector Vect);
void ScaleTriangle(ObjectStruct *Triangle, Vector Vect);
int IsTriangleIntersection(ObjectStruct *Triangle, Vector Origin, Vector Direction);
int ClickInTriangleXY(ObjectStruct *Triangle, gdouble x, gdouble y);
int ClickInTriangleXZ(ObjectStruct *Triangle, gdouble x, gdouble y);
int ClickInTriangleZY(ObjectStruct *Triangle, gdouble x, gdouble y);
void ToolNewTriangle(GtkWidget *DrawingArea, GdkEventButton *bevent);
ObjectStruct *CreateTriangle(Vector P1, Vector P2, Vector P3);
int PDBCreateTriangle(int *Id, Vector *V1, Vector *V2, Vector *V3);
