/* utils.c
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999 David Odin <David.Odin@bigfoot.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "giram.h"
#include "utils.h"

/*****************************************************************************
*  AddLibraryPath
******************************************************************************/
LibraryPathList *AddLibraryPath(char *NewPath)
{
  LibraryPathList *Tmp;
  Tmp = g_malloc(sizeof(LibraryPathList));
  Tmp->Next = LibraryPaths;
  Tmp->PathName = g_malloc(strlen(NewPath)+1);
  strcpy(Tmp->PathName, NewPath);
  LibraryPaths = Tmp;
  return Tmp;
}

/*****************************************************************************
*  LibOpen
******************************************************************************/
FILE *LibOpen(char *Name)
{
  FILE *h;
  LibraryPathList *Tmp;
  char FileName[1024];

  if ((h=fopen(Name,"rb")) != NULL)
  {
    return h;
  }
  for (Tmp=LibraryPaths ; Tmp ; Tmp=Tmp->Next)
  {
    strcpy(FileName, Tmp->PathName);
    strcat(FileName, "/");
    strcat(FileName, Name);
    if ((h=fopen(FileName, "rb")) != NULL)
    {
      return h;
    }
  }
  return NULL;
}

/*****************************************************************************
*  WarningBox
******************************************************************************/
void WarningBox(gchar *Name, const gchar *format, ...)
{
  GtkWidget *Dialog;
  GtkWidget *Label;
  GtkWidget *Button;
  va_list args;
  gchar *string;

  va_start(args, format);
  string = g_strdup_vprintf(format, args);
  va_end(args);

  Dialog = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(Dialog), Name);
  gtk_container_set_border_width(GTK_CONTAINER(GTK_DIALOG(Dialog)->vbox), 5);
  Button = gtk_button_new_with_label("Close");
  gtk_signal_connect_object(GTK_OBJECT(Button), "clicked",
                            (GtkSignalFunc)gtk_widget_destroy,
                            GTK_OBJECT(Dialog));
  GTK_WIDGET_SET_FLAGS(Button, GTK_CAN_DEFAULT);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialog)->action_area), Button, TRUE, TRUE, 0);
  gtk_widget_grab_default(Button);
  gtk_widget_show(Button);
  
  Label = gtk_label_new(string);
  gtk_label_set_justify(GTK_LABEL(Label), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap(GTK_LABEL(Label), TRUE);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialog)->vbox), Label, FALSE, FALSE, 0);
  gtk_widget_show(Label);
  gtk_widget_show(Dialog);
  printf(string);
  g_free(string);
}

