#!/bin/sh
#
# Startup script for the adzapper filtering proxy 
#
# chkconfig:
# description: adzapper is a filtering proxy for the World Wide Web. \
#              It is used primarily to prevent ads from being displayed \
#              by web browsers.
# processname: adzapperd
# pidfile: /var/run/adzapper.pid
# config: 

# Source function library.
. /etc/rc.d/init.d/functions

# See how we were called.
case "$1" in
  start)
	echo -n "Starting adzapperd: "
	daemon adzapperd
	echo
	touch /var/lock/subsys/adzapperd
	;;
  stop)
	echo -n "Shutting down adzapperd: "
	killproc adzapperd
	echo
	rm -f /var/lock/subsys/adzapperd
	rm -f /var/run/adzapperd.pid
	;;
  status)
	status adzapperd
	;;
  restart)
	$0 stop
	$0 start
	;;
  reload)
	echo -n "Reloading adzapperd: "
	killproc adzapperd -HUP
	echo
	;;
  *)
	echo "Usage: $0 {start|stop|restart|reload|status}"
	exit 1
esac

exit 0
