/*
 * IceWM
 *
 * Copyright (C) 1998,1999 Marko Macek
 *
 * AddressBar
 */
#include "config.h"
#include "ykey.h"
#include "aaddressbar.h"

#ifdef CONFIG_ADDRESSBAR
#include "yapp.h"
#include "sysdep.h"
#include "default.h"

AddressBar::AddressBar(YWindow *parent): YInputLine(parent) {
}

AddressBar::~AddressBar() {
}

bool AddressBar::handleKey(const XKeyEvent &key) {
    if (key.type == KeyPress) {
        KeySym k = XKeycodeToKeysym(app->display(), key.keycode, 0);
        int m = KEY_MODMASK(key.state);

        if (k == XK_KP_Enter || k == XK_Return) {
            const char *t = getText();
            if (m & ControlMask) {
                const char *args[6];
                args[0] = terminalCommand;
                args[1] = "-e";
                args[2] = getenv("SHELL");;
                args[3] = "-c";
                args[4] = t;
                args[5] = 0;
                if (t == 0 || t[0] == 0)
                    args[1] = 0;
                app->runProgram(terminalCommand, args);
            } else {
                const char *args[4];
                args[0] = getenv("SHELL");;
                args[1] = "-c";
                args[2] = t;
                args[3] = 0;
                app->runProgram(getenv("SHELL"), args);
            }
            selectAll();
            return true;
        }
    }
    return YInputLine::handleKey(key);
}

#endif
