// //////////////////////////////////////////////////////////////////////////
// IceWM: src/pppstatus.h
//
//
// PPP Status
//
// //////////////////////////////////////////////////////////////////////////
#ifndef NETSTATUS_H
#define NETSTATUS_H

#ifdef linux
#ifdef CONFIG_NET_STATUS

#define HAVE_NET_STATUS

#include "ywindow.h"
#include "ytimer.h"

#include <sys/socket.h>
//#include <sys/ioctl.h>  // ioctl(2)

#define NET_UPDATE_INTERVAL 500
#define NET_SAMPLES 20

class NetStatus: public YWindow, public YTimerListener {
public:
    NetStatus(YWindow *aParent = 0);
    ~NetStatus();
private:
    YColor *color[3];
    YTimer *fUpdateTimer;
    int maxBytes;

    int ppp_in[NET_SAMPLES];
    int ppp_out[NET_SAMPLES];
    int ppp_tot[NET_SAMPLES];

    unsigned long prev_ibytes;
    unsigned long prev_obytes;

    struct timeval prev_time;

    bool wasUp;               // previous link status

    // methods local to this class
    bool isUp();
    void getCurrent(int *in, int *out, int *tot);
    void updateStatus();


    // methods overloaded from superclasses
    virtual bool handleTimer(YTimer *t);
    virtual void paint(Graphics & g, int x, int y, unsigned int width, unsigned int height);
};

#endif

#endif

#endif
