// Taken from blackbox window manager by Brad Hughes
// http://blackbox.wiw.org 
//
// --------------------------------------------------------------------------
// I've only included it so that I could make the windows decorations look 
// nicer. I plan for my own graphics class similar to this but smaller 
// and only included needed functions.
// --------------------------------------------------------------------------
//
#ifndef _graphics_hh
#define _graphics_hh

typedef struct _BColor {
  int r, 
    g,
    b,
    a;
} BColor;

class BImage {
private:
  int depth;
  unsigned long *data;
  unsigned int width, height;

  BColor bg_color;

protected:
  
public:
  //  BImage(void);
  BImage(unsigned int, unsigned int, int, unsigned long * = 0);
  BImage(unsigned int, unsigned int, int, const BColor &);
  BImage(unsigned int, unsigned int, int, unsigned char, unsigned char,
	 unsigned char);
  BImage(XImage *);
  ~BImage(void);
  
  XImage *convertToXImage(Display *, Visual *);
  Pixmap convertToPixmap(Display *, Visual *, Window);
  unsigned long convertToPixel(const BColor &);
  const BColor &convertToBColor(unsigned long);

  void setBackgroundColor(const BColor &);
  void setBackgroundColor(unsigned char, unsigned char, unsigned char);
  void renderBevel(void);
  void renderButton(void);
  void invertImage(void);
  void renderHGradient(const BColor &from, const BColor &to);
  void renderVGradient(const BColor &from, const BColor &to);
};


#endif
