#include "sapphire.hh"

InputBuffer::InputBuffer(char* infileName)
{
	lineCount=0;
	currentChar='\0';
	currentLine=0;	
	
	if((inputfile=fopen(infileName, "r")) == NULL)
	{
		printf("Error trying to open file: %s\n", infileName);
		exit(0);
	} else {
	 	inputfileName = infileName; 
	}
}

char* InputBuffer::getLine(int num)
{
	rewind(inputfile);

	char* line = new char[MaxBufferSize];
	
	strcpy(inBuffer, line);
	
	for(int i=0;i<num;i++)
	{
		fgets(inBuffer, MaxBufferSize, inputfile);
	}
	
	strcpy(line, inBuffer);	

	delete [] line;

	return line;
}

// Prints the file to screen and displays total number of lines.
void InputBuffer::list()
{
	char Char='\0';
	
	for(int i=0; i<MaxBufferSize; i++)
	{
	  	if(Char == '\n') 
		{
			i=0;
			lineCount++;
		}

		Char=getc(inputfile);
			
		if(!(Char==-1))
		{
			printf("%c", Char);
		}
	}


	printf("\n\n-----------------------------------------------------\n");
	printf("total lines: %d \n", lineCount);
}

void InputBuffer::printFile(bool file)
{
	char* line = new char[MaxBufferSize];
	
	strcpy(inBuffer, line);
	
	int lineNum=0;
	
	char* outfile=0;
	
	strcpy(outfile, inputfileName);
			
	char* append="_with_line_numbers";
	
	if(file)
	{
		strcat(outfile, append);
	
		FILE *out;
	
		if((out=fopen(outfile, "w")) == NULL)
		{
			printf("Error trying to open file!");
			exit(0);
		} 
	
		fprintf(out,"//----------------------------------------------------------------------//\n");
		fprintf(out,"// This is the %s source file with line numbers printed\n", inputfileName);
		fprintf(out,"//\n");
		fprintf(out,"//----------------------------------------------------------------------//\n");
	
		while(!feof(inputfile)) {
		
			fgets(line, MaxBufferSize, inputfile);
		
			fprintf(out, "%d : \t %s", lineNum, line);
		
			lineNum++;		
		} 
	
		fclose(out);
	
	} else {
	
		while(!feof(inputfile)) {
		
			fgets(line, MaxBufferSize, inputfile);
		
			printf("%d : \t %s", lineNum, line);
		
			lineNum++;		
		} 
		
	}
		
	delete [] line;
}

// Returns the total number of lines in source file.
int InputBuffer::getLineTotal()
{
	rewind(inputfile);
	
	char* line = new char[MaxBufferSize];
	
	strcpy(inBuffer, line);

	while(!feof(inputfile)) {
		
		fgets(line, MaxBufferSize, inputfile);

		lineCount++;
		
	} 
	
	delete [] line;

	return lineCount;
}

int InputBuffer::countChars()
{
	rewind(inputfile);
	
	int num=0;

	while(!(feof(inputfile)))
	{
		getc(inputfile);
		num++;
	}

	return num;
}

char InputBuffer::getChar()
{
	return currentChar = getc(inputfile);
}
