#ifndef _inputbuffer_h_
#define _inputbuffer_h_

//-------------------------------------------------------------------------------------------//
// Input Buffer Class 									     
// This class opens the input file and maintains a pointer to it. It also provides various 
// functions to get information about the file or print the file out with line numbers.
//-------------------------------------------------------------------------------------------//
class InputBuffer
{
public:
	FILE *inputfile;	// FILE pointer to input file

protected:
	char *inputfileName;    // Input file name
	char inBuffer[MaxBufferSize]; // Buffer to put current line in
	char currentChar; // Current character we are processing
	int lineCount;
	int currentLine;

public:
	InputBuffer(char* inputfileName);
	~InputBuffer() { fclose(inputfile); }
	
	// Returns the filename of input file
	char *getfileName() const { return inputfileName; }
	
	// Input member functions
	//char getChar() { return currentChar = getc(inputfile); }
	char getChar();
	char* getLine(int num);
	
	// Get total lines in file
	int  getLineTotal();

	int countChars();

	// Extra member functions to print file and list file
	void list();
	void printFile(bool file);
	
	void rewindFile() { rewind(inputfile); }
};

#endif
