// menu.cc
//
// In parts this code is less than ideal. There will be major work done to this code
// in the future.
//
// Frank Hale 
// frankhale@yahoo.com
#include "sapphire.hh"

Menu::Menu() {

	mi = new LinkedList<MenuItem>;
	
	menuTitle=windowmanager_version;

	counter=0;

	font = XLoadQueryFont(wm->dpy, MENU_FONT);
	if (!font) font = XLoadQueryFont(wm->dpy, MENU_FONT);

	XGCValues gv;
	gv.function = GXcopy;
	gv.foreground = wm->fg.pixel;
	gv.font = font->fid;
	menu_gc = XCreateGC(wm->dpy, wm->root, GCFunction | GCForeground | GCFont, &gv);
	
  	create_mask = CWBackPixmap | CWBackPixel | CWBorderPixel |
   	 CWOverrideRedirect | CWEventMask;
  	attrib.background_pixmap = None;
  	attrib.background_pixel = wm->bg.pixel;
  	attrib.border_pixel = wm->bd.pixel;
  	attrib.override_redirect = True;
  	attrib.event_mask = ButtonPressMask|ButtonReleaseMask|
    	ButtonMotionMask|ExposureMask|EnterWindowMask|LeaveWindowMask;

	frame.x = 0;
  	frame.y = 0;
	frame.height=0;
	frame.width=0;
    
    	item_width = frame.width + 20;
	item_height = font->ascent + font->descent + 8;
	
	isVisible=False;
	
}

Menu::~Menu() {
	LinkedListIterator<MenuItem> it(mi);
	for(; it.current(); it++)
	{
		mi->remove(it.current());
	}
	
	LinkedListIterator<Menu> sm(submenus);
	for(; sm.current(); sm++)
	{
		submenus->remove(sm.current());
	}
	
	XFreePixmap(wm->dpy, title_pix);
	XFreePixmap(wm->dpy, menu_pix);
	
	delete submenus;
	delete mi;
}

void Menu::doMenu()
{
	isVisible=False;
	
	LinkedListIterator<MenuItem> it(mi);
	
	int temp_width=0;
	int temp_ascent=0;
	int temp_descent=0;
	
	unsigned int count=0;
	unsigned int char_count=0;


	for(; it.current(); it++)
	{
		char_count = strlen(it.current()->name);

    		XTextExtents(font, it.current()->name , char_count, &direction, &ascent, 
            		&descent, &overall);		

		if (char_count < strlen(menuTitle)) {
		
			char_count = strlen(menuTitle);
			
			XTextExtents(font, menuTitle , char_count, &direction, &ascent, 
		           &descent, &overall);		
		}
	
		if (char_count > count) {
			count = char_count; 
			temp_width  = overall.width;
			temp_ascent = overall.ascent;
			temp_descent= overall.descent;
		}
		
	}
	
	frame.width = temp_width + 40;
	item_width  = temp_ascent + temp_descent+9;
	frame.height = item_width * mi->count();
	item_x = item_width/2+4;
	item_y = item_height/2+4;

	frame.window =
    		XCreateWindow(wm->dpy, wm->root, frame.x, frame.y,
		  frame.width, frame.height, 1, DefaultDepth(wm->dpy, wm->screen),
		  InputOutput, DefaultVisual(wm->dpy, wm->screen), create_mask, &attrib);

	frame.title =
    		XCreateWindow(wm->dpy, wm->root, frame.x, frame.y,
		  frame.width, frame.height+25, 1, DefaultDepth(wm->dpy, wm->screen),
		  InputOutput, DefaultVisual(wm->dpy, wm->screen), create_mask, &attrib);

	XReparentWindow(wm->dpy, frame.window, frame.title, -1, 20);
		
	BImage image(frame.width, frame.height, DefaultDepth(wm->dpy, wm->screen),
		wm->theme->getMenuColorFrom());
	image.renderHGradient(wm->theme->getMenuColorFrom(), 
			      wm->theme->getMenuColorTo());
	it.reset();
	for(; it.current(); it++)
	{
		it.current()->window = createItemWindow();
		menu_pix = image.convertToPixmap(wm->dpy, DefaultVisual(wm->dpy, wm->screen),
		it.current()->window);
		XSetWindowBackgroundPixmap(wm->dpy, it.current()->window, menu_pix);
	}

	image.renderVGradient(wm->theme->getMenuColorFrom(), wm->theme->getMenuColorTo());
	title_pix = image.convertToPixmap(wm->dpy, DefaultVisual(wm->dpy, wm->screen),
		frame.title);
	XSetWindowBackgroundPixmap(wm->dpy, frame.title, title_pix);
	
	curs = XDefineCursor(wm->dpy, frame.window, XCreateFontCursor(wm->dpy, XC_left_ptr));

	// Menu Select image.............
	BImage simage(frame.width, frame.height, DefaultDepth(wm->dpy, wm->screen),
		wm->theme->getMenuColorTo());
	simage.renderHGradient(wm->theme->getMenuSelectColorTo(), wm->theme->getMenuSelectColorFrom());

	select_pix = simage.convertToPixmap(wm->dpy, DefaultVisual(wm->dpy, wm->screen),
	frame.title);
	// ------------------------------
}

void Menu::insertMenuItems()
{
 // this is handled in a derived class
}

void Menu::redraw()
{
 	// We need an Iterator for our menu items. This lets us traverse through
	// the list. 
	LinkedListIterator<MenuItem> it(mi);
	
	for(; it.current(); it++)
	{
		XClearWindow(wm->dpy, it.current()->window);
	  	
		XDrawString(wm->dpy, it.current()->window, menu_gc, 
		   item_x, item_y, it.current()->name, strlen(it.current()->name));
	}
	
	XDrawString(wm->dpy, frame.title, menu_gc, 
   	   8, 14 , menuTitle, strlen(menuTitle));

}

void Menu::redraw(MenuItem *m)
{
	XClearWindow(wm->dpy, m->window);
	  	
	XDrawString(wm->dpy, m->window, menu_gc, 
		   item_x, item_y, m->name, strlen(m->name));
	
	XDrawString(wm->dpy, frame.title, menu_gc, 
   	   8, 14 , menuTitle, strlen(menuTitle));
}


void Menu::insert(char *n, char *exec, int id, int sub, int func)
{
	MenuItem *item = new MenuItem();
	
	item->window = None;
	item->name = n;
	item->exec = exec;
	item->index = id;
	item->sub  = sub;
	item->function = func;

	mi->insert(item);
}

void Menu::execute(char *s)
{
	char command[strlen(s)+8];
	
	/*if(wm->opt_display != NULL)
	{
		char *displayString = new char[strlen(wm->opt_display)+10];
		sprintf(displayString, "DISPLAY=%s", wm->opt_display);
		putenv(displayString);
	}
	*/

	sprintf(command, "exec %s &", s);
	system(command);
}

void Menu::show(bool state)
{	
	if(state)
	{  
		isVisible=True;
		
		// Gets the coordinates of the mouse
		Client *c = NULL;
		c->get_mouse_position(&frame.x, &frame.y);
		
		// Move the menu to the position of the mouse pointer
		XMoveWindow(wm->dpy, frame.title, frame.x, frame.y);
		// Show the menu windows
		XMapRaised(wm->dpy, frame.title);
		XMapRaised(wm->dpy, frame.window);
		XMapSubwindows(wm->dpy,frame.window);
	} else {
		
		isVisible=False;
		
		// hide the menu windows
		XUnmapSubwindows(wm->dpy, frame.window);
		XUnmapWindow(wm->dpy, frame.window);
		XUnmapWindow(wm->dpy, frame.title);
	}
}

void Menu::showSub(int x, int y)
{	
	isVisible=True;
	
	XMoveWindow(wm->dpy, frame.title, x, y);

	// Show the menu windows
	XMapRaised(wm->dpy, frame.title);
	XMapRaised(wm->dpy, frame.window);
	XMapSubwindows(wm->dpy,frame.window);
}

void Menu::hideSub()
{
	isVisible=False;
	
	// hide the menu windows
	XUnmapSubwindows(wm->dpy, frame.window);
	XUnmapWindow(wm->dpy, frame.window);
	XUnmapWindow(wm->dpy, frame.title);
}

Window Menu::createItemWindow() {
  unsigned long attrib_mask = CWBackPixmap|CWBackPixel|CWBorderPixel|CWCursor|
    CWEventMask;
  
  XSetWindowAttributes attrib;
  attrib.background_pixmap = None;
  attrib.background_pixel = wm->bg.pixel;
  attrib.border_pixel = wm->fg.pixel;
  attrib.override_redirect = True;
  attrib.cursor = XCreateFontCursor(wm->dpy, XC_left_ptr);
  attrib.event_mask = ButtonPressMask|ButtonReleaseMask| PointerMotionMask |
    ButtonMotionMask|ExposureMask|EnterWindowMask|LeaveWindowMask;
  
  Window c =
    XCreateWindow(wm->dpy, frame.window, 0, frame.height/mi->count()*counter,
		 frame.width, item_height, 0, DefaultDepth(wm->dpy, wm->screen),
		  InputOutput, DefaultVisual(wm->dpy, wm->screen), attrib_mask, &attrib);
  counter++;
  
  return c;
}

MenuItem *Menu::findMenuItemWindow(Window w)
{
	if(mi->count()) 
	{
		LinkedListIterator<MenuItem> it(mi);
		for(; it.current(); it++)
		{
			if (w == it.current()->window)
			{
				return it.current();
			}				
		}
		
	}

	return NULL;
}

MenuItem *Menu::findMenuItem(int sub)
{
	if(mi->count()) 
	{
		LinkedListIterator<MenuItem> it(mi);
		for(; it.current(); it++)
		{
			if (sub == it.current()->sub)
			{
				return it.current();
			}				
		}		
	}

	return NULL;
}

void Menu::handle_button_event(XButtonEvent *e)
{
	MenuItem *m = findMenuItemWindow(e->window);

	if(m)
	{
		switch (e->button) {
			case Button1:
			{
				if(e->window == m->window)
				{
					// 99 means that it doesn't serve as a wm function
					if(m->function == 99) 
					{
						execute(m->exec);
						
					} else {
					
						switch(	m->function )
						{
							// function 1 is wm shutdown
							case 1:
							{
								wm->quit_nicely();
							}
							break;
						
							// theme function
							case 2:
							{ 
								wm->doTheme(m->exec);
							}
							break;
						
						}										
					}
					
					// This will become configurable
											
					// this hides all menu's when finished
					LinkedListIterator<Menu> sm(submenus);
					for(; sm.current(); sm++)
					{
						if(sm.current()->isVisible)
						{
							sm.current()->hideSub();
						}
					}
					
					// Close the root menu.
					wm->closeRootMenu();
					
				} 
			break;
			}

			case Button2:
			{
			break;
			}
			
			case Button3:
			{
			break;
			}
		}
	} else {
	
		switch (e->button) {
			case Button1:
			{
				if(e->window == frame.title)
				{ 
					XRaiseWindow(wm->dpy, frame.title);
					move();
				}
				
			break;
			}

			case Button2:
			{	
			break;
			}
			case Button3:
			{	
				if(e->window == frame.title)
				{ 
					show(False);
					
					LinkedListIterator<Menu> sm(submenus);
					for(; sm.current(); sm++)
					{
						if(sm.current()->isVisible)
						{
							sm.current()->hideSub();
						}
					}
				}
			break;
			}
		}
	}
}

void Menu::move()
{
	XEvent ev;

	if (!grab(wm->root, MouseMask, wm->move_curs)) return;
	XGrabServer(wm->dpy);
	
	for (;;) {
		XMaskEvent(wm->dpy, MouseMask, &ev);
		switch (ev.type) {
			case MotionNotify:
				XMoveWindow(wm->dpy, frame.title, ev.xmotion.x , ev.xmotion.y);
				break;
			case ButtonRelease:
				XSync(wm->dpy, False);
				XUngrabServer(wm->dpy);
				ungrab();
				return;
		}
	}

}

// This function should be useful when I implement
// menus on the toolbar. 
void Menu::setMenuPos(int x, int y)
{
	frame.x = x; frame.y = y;
	XMoveWindow(wm->dpy, frame.title, frame.x, frame.y);
}

void Menu::handle_enter_notify(XCrossingEvent *e)
{
	MenuItem *m = findMenuItemWindow(e->window);
	
	if(m)
	{	
	XSetWindowBackgroundPixmap(wm->dpy, m->window, select_pix);

	LinkedListIterator<Menu> sm(submenus);
	for(; sm.current(); sm++)
	{
		LinkedListIterator<MenuItem> smi(sm.current()->mi);
		for(; smi.current(); smi++)
		{
			if(m->index != smi.current()->index)
			{				
				if(sm.current()->isVisible)
				{
					sm.current()->hideSub();
				}
			}
		}
	}
	
	redraw(m);
	} 
}

void Menu::handle_leave_notify(XCrossingEvent *e)
{
	MenuItem *m = findMenuItemWindow(e->window);
	
	if(m)
	{
	XSetWindowBackgroundPixmap(wm->dpy, m->window, menu_pix);

	redraw(m);
	} 
}

void Menu::handle_expose_event(XExposeEvent *e)
{
	MenuItem *m = findMenuItemWindow(e->window);
	
	if(m)
	{
	redraw(m);
	}
}

void Menu::handle_motion_notify_event(XMotionEvent *e)
{
	MenuItem *m = findMenuItemWindow(e->window);

	XWindowAttributes attrib;
	XWindowAttributes i_attrib;
	if(m) {
		i = m->index;

		if(m->sub != 99)
		{
			XGetWindowAttributes(wm->dpy, frame.title, &attrib);
			XGetWindowAttributes(wm->dpy, m->window, &i_attrib);
			subm = findSubMenu(m->sub);
			if(!subm->isVisible)
			{
				subm->showSub(attrib.x+attrib.width,attrib.y + i_attrib.y);
			} 
			
		} 
		
	}

}

void Menu::handle_config_notify_event(XConfigureEvent *e)
{
	frame.x = e->x; frame.y = e->y;
}

void Menu::reconfigure()
{	
	BImage image(frame.width, frame.height, DefaultDepth(wm->dpy, wm->screen),
		wm->theme->getMenuColorFrom());
	image.renderHGradient(wm->theme->getMenuColorFrom(), 
			      wm->theme->getMenuColorTo());

	LinkedListIterator<MenuItem> it(mi);		      
	for(; it.current(); it++)
	{
		menu_pix = image.convertToPixmap(wm->dpy, DefaultVisual(wm->dpy, wm->screen),
		it.current()->window);
		XClearWindow(wm->dpy, it.current()->window);
		XSetWindowBackgroundPixmap(wm->dpy, it.current()->window, menu_pix);
		redraw();
	}

	// Menu select image....
	BImage simage(frame.width, frame.height, DefaultDepth(wm->dpy, wm->screen),
		wm->theme->getMenuColorTo());
	simage.renderHGradient(wm->theme->getMenuSelectColorTo(), wm->theme->getMenuSelectColorFrom());

	select_pix = simage.convertToPixmap(wm->dpy, DefaultVisual(wm->dpy, wm->screen),
	frame.title);
	// ----------------------

	image.renderVGradient(wm->theme->getMenuColorFrom(), wm->theme->getMenuColorTo());
	title_pix = image.convertToPixmap(wm->dpy, DefaultVisual(wm->dpy, wm->screen),
		frame.title);
	XClearWindow(wm->dpy, frame.title);
	XSetWindowBackgroundPixmap(wm->dpy, frame.title, title_pix);
	
	redraw();
}

Menu *Menu::findSubMenu(int sub)
{
	return submenus->find(sub);
}
