// menu.hh
//
// Frank Hale 
// frankhale@yahoo.com
#ifndef _MENU_HH_
#define _MENU_HH_

class Menu
{
private:
	int i;

	char* menuTitle;
	
	BColor col_to;	
	BColor col_from;
	BColor select_to;
	BColor select_from;
	Pixmap menu_pix;
	Pixmap select_pix;
	Pixmap title_pix;
	XSetWindowAttributes attrib;
	unsigned long create_mask;	
	GC menu_gc;
	XFontStruct *font;
	XCharStruct overall;
	int direction, ascent, descent;
	int counter;
	
	struct frame {
		Window title;
		Window window;
		int x,y;
		unsigned int width,height;
	} frame;
	
	unsigned int item_width,item_height;
	int item_x, item_y;
	
	Menu *subm;
	LinkedList<Menu>* submenus;

	Cursor curs;
	
public:
	bool isVisible;
	LinkedList<MenuItem> *mi;	
		
	Menu();
	virtual ~Menu();
		
	LinkedList<MenuItem>* getMenuItemList() const { return mi; }
	
	void 		      setMenuTitle(char* t) { menuTitle=t; }
	void                  setMenuItemList(LinkedList<MenuItem>* m) { mi=m; }
	unsigned int          getFrameHeight() const { return frame.height; }
	Window		      getFrameTitleWindow() const { return frame.title; }
			
	void redraw(MenuItem *m);
	void redraw();
	void setMenuPos(int x, int y);
	virtual void show(bool state=false);
	void showSub(int x, int y);
	virtual void handle_button_event(XButtonEvent *e);
	virtual void handle_enter_notify(XCrossingEvent *e);
	virtual void handle_leave_notify(XCrossingEvent *e);
	virtual void handle_expose_event(XExposeEvent *e);
	virtual void handle_motion_notify_event(XMotionEvent *e);
	virtual void handle_config_notify_event(XConfigureEvent *e);
	void doMenu();
	virtual void insertMenuItems();
	virtual void insert(char *, char *,int id, int sub, int func);
	MenuItem *findMenuItemWindow(Window w);
	MenuItem *findMenuItem(int sub);
	virtual void execute(char *s);
		
	void setSubMenuList(LinkedList<Menu>* subs) 
	{ submenus = new LinkedList<Menu>; submenus = subs; }
	
	Menu* findSubMenu(int sub);
	void hideSub();

	void reconfigure();

protected:

	Window createItemWindow();
	void move();

};

#endif
