#ifndef _MENULEXER_HH_
#define _MENULEXER_HH_

class MenuLexer : public Scanner
{
protected:
	char *temp;
	char *var;
	char *current_token;

	int function;
	int submenu_counter;
	
	LinkedList<Data> *variables;
	
	RootMenu *rootmenu;
	
	bool createMenu;
	bool error;
	
public:
	MenuLexer(char *fileName, RootMenu *rm);
	~MenuLexer();
	
	void analyze();
	bool match(char *tok);
	void expected(char *err);

	void getNextToken(bool spaces) { current_token = getToken(spaces); }
		
	// functions for the language grammar

	bool menu(bool createMenu);
	bool submenu(bool createMenu);
	bool item(bool createMenu);
	bool submenuitem(bool createMenu);
	bool comments();
	bool statement();
	bool quoted_text();
	bool variable();
	bool exit(bool createMenu);

	bool submenutheme(bool createMenu);
	bool theme(bool createMenu);
	
	bool isVariable();
	bool isError() { return error; }
	
	void createTheMenu() { createMenu = True; }
};

#endif 
