// misc.cc
//
// Frank Hale 
// frankhale@yahoo.com
#include "sapphire.hh"

void err(char *fmt, ...)
{
	va_list argp;

	fprintf(stderr, "%s: ", windowmanager_name);
	va_start(argp, fmt);
	vfprintf(stderr, fmt, argp);
	va_end(argp);
	fprintf(stderr, "\n");
}

#ifdef DEBUG
void show_event(XEvent e)
{
	char *s;
	Window w;

	switch (e.type) {
		case ButtonPress:
			s = "ButtonPress"; w = e.xbutton.window; break;
		case ButtonRelease:
			s = "ButtonRelease"; w = e.xbutton.window; break;
		case ClientMessage:
			s = "ClientMessage"; w = e.xclient.window; break;
		case ColormapNotify:
			s = "ColormapNotify"; w = e.xcolormap.window; break;
		case ConfigureNotify:
			s = "ConfigNotify"; w = e.xconfigure.window; break;
		case ConfigureRequest:
			s = "ConfigRequest"; w = e.xconfigurerequest.window; break;
		case CreateNotify:
			s = "CreateNotify"; w = e.xcreatewindow.window; break;
		case DestroyNotify:
			s = "DestroyNotify"; w = e.xdestroywindow.window; break;
		case EnterNotify:
			s = "EnterNotify"; w = e.xcrossing.window; break;
		case Expose:
			s = "ExposeEvent"; w = e.xexpose.window; break;
		case MapNotify:
			s = "MapNotify"; w = e.xmap.window; break;
		case MapRequest:
			s = "MapRequest"; w = e.xmaprequest.window; break;
		case MappingNotify:
			s = "MappingNotify"; w = e.xmapping.window; break;
		case MotionNotify:
			s = "MotionNotify"; w = e.xmotion.window; break;
		case PropertyNotify:
			s = "PropertyNotify"; w = e.xproperty.window; break;
		case ReparentNotify:
			s = "ReparentNotify"; w = e.xreparent.window; break;
		case ResizeRequest:
			s = "ResizeRequest"; w = e.xresizerequest.window; break;
		case UnmapNotify:
			s = "UnmapNotify"; w = e.xunmap.window; break;
		default:
			s = "unknown event"; w = None; break;
	}

	err("recieved %s,\twindow = %#x", s, w);
}


#endif
