#include "sapphire.hh"

RootMenu::RootMenu() : Menu() 
{
	submenus = new LinkedList<Menu>;
	Menu *sub = new Menu();
	sub=NULL;
}

RootMenu::~RootMenu() 
{
	LinkedListIterator<Menu> it(submenus);
	for(; it.current(); it++)
	{
		submenus->remove(it.current());
	}
	
	delete submenus;
	delete sub;
}

void RootMenu::insertMenuItems() 
{	
	char menuPath[strlen("menu")+strlen(HOME)+11];
	sprintf(menuPath, "%s/.sapphire/%s", HOME, "menu");
	
	MenuLexer *l = new MenuLexer(menuPath, this);
	l->analyze();
	
	if(! l->isError()) {
		l->rewindFile();
		l->createTheMenu();
		l->analyze();
	} else {
		
		printf("using default menu...\n");
		defaultMenu();
	}
	
	delete l;
}

void RootMenu::defaultMenu()
{
	setMenuTitle("Default Menu");
	
	insert("Xterm", "xterm", 0,99,99);
	insert("exit", "", 0, 99,1);
	
	doMenu();
	
	setSubMenuList(submenus);
}
