#ifndef _THEME_HH_
#define _THEME_HH_

class Theme
{
private:
	
	// These represet a color pair which is color_from and color_to
	// used for the gradients.
	BColor client[2];
	BColor titlebarButtons[2];
	BColor menu[2];
	BColor menu_select[2];
	BColor toolbar[2];
	BColor root[3];
	bool toolbartop;
	
public:
	Theme();
	~Theme();

	BColor getClientColorFrom() const { return client[0]; }
	BColor getClientColorTo() const { return client[1]; }
	
	BColor getTitleBarButtonColorFrom() const { return titlebarButtons[0]; }
	BColor getTitleBarButtonColorTo() const { return titlebarButtons[1]; }
	
	BColor getMenuColorFrom() const { return menu[0]; } 
	BColor getMenuColorTo() const { return menu[1]; }

	BColor getMenuSelectColorFrom() const { return menu_select[0]; }
	BColor getMenuSelectColorTo() const { return menu_select[1]; }

	BColor getToolbarColorFrom() const { return toolbar[0]; }
	BColor getToolbarColorTo() const {return toolbar[1]; }
	
	BColor getRootColorFrom() const { return root[0]; }
	BColor getRootColorTo() const { return root[1]; }
	BColor getRootColor() const { return root[2]; }
	bool getToolbarLocationTop() const {return toolbartop; }
	
	void setClientColorFrom(BColor ccf);
	void setClientColorTo(BColor cct);
	
	void setTitlebarButtonColorFrom(BColor tbbcf);
	void setTitlebarButtonColorTo(BColor tbbct);
	
	void setMenuColorFrom(BColor mcf);
	void setMenuColorTo(BColor mct);

	void setMenuSelectColorFrom(BColor mscf);
	void setMenuSelectColorTo(BColor msct);

	void setToolbarColorFrom(BColor tcf);
	void setToolbarColorTo(BColor tct);
	
	void setRootColor(BColor rc);
	void setRootColorFrom(BColor rc);	
	void setRootColorTo(BColor rc);
	
	void setToolbarLocationTop(bool stblt); 
};

#endif
