#ifndef _THEMELEXER_HH_
#define _THEMELEXER_HH_

class ThemeLexer : public Scanner
{
protected:
	char *temp;
	char *var;
	char *current_token;

	LinkedList<Data> *variables;
	
	BColor color_temp;
	
	Pixmap root_pix;
	
public:
	ThemeLexer(char *fileName);
	~ThemeLexer();
	
	void analyze();
	bool match(char *tok);
	void expected(char *err);

	void getNextToken(bool spaces) { current_token = getToken(spaces); }
		
	// functions for the language grammar

	bool theme();

	bool comments();
	bool statement();
	bool quoted_text();
	bool variable();

	bool titlebar_color_from();
	bool titlebar_color_to();
	bool menu_color_from();
	bool menu_color_to();
	bool menu_select_color_from();
	bool menu_select_color_to();
	bool toolbar_color_from();
	bool toolbar_color_to();
	bool root_color();
	bool titlebar_button_color_from();
	bool titlebar_button_color_to();
	bool show_root_color();
	bool root_color_from();
	bool root_color_to();	
	bool set_root_vgradient();
	bool set_root_hgradient();
	bool set_toolbar_location_top();
	
	bool r();
	bool g();
	bool b();
	bool a();
	
	bool execute();
	
	bool isVariable();
};

#endif 
