// wm.hh
//
// Frank Hale 
// frankhale@yahoo.com
#ifndef _WM_HH_
#define _WM_HH_

#include "sapphire.hh"

class WindowManager {

private:
	Toolbar *t;
	LinkedList<Menu> *subs;
		
public:	/* variables */
	Theme *theme;
	RootMenu *rm;

	LinkedList<Client> *ClientList;

	struct logo {
	    Pixmap default_logo, default_mask;
	    XpmAttributes *default_attrib;
	} logo;

	Display		*dpy;
	int		screen;
	Window		root;
	int             xres,yres;
	GC		invert_gc;
	GC		string_gc;
	GC		border_gc;
	XFontStruct	*font;
	int		iheight;
	XColor		fg, bg, bd, bg2;
	Client		*head_client;
	Atom		xa_wm_state;
	Atom		xa_wm_change_state;
	Atom		xa_wm_protos;
	Atom		xa_wm_delete;
	Atom		xa_wm_cmapwins;
	Cursor		move_curs;
	Cursor		resize_curs;
	Cursor		menu_curs;
	char		*opt_display;
	char		*opt_font;
	char		*opt_fg;
	char		*opt_bg;
	char		*opt_bd;
	char 		*opt_bg2;
	#ifdef SHAPE
	Bool		shape;
	int		shape_event;
	#endif

	char* alternateThemePath;

public: /* member functions */

	bool button1pressed;
	bool button2pressed;
	bool button3pressed;
	
	WindowManager(int argc, char **argv);
	~WindowManager();
	
	void setup_display();
	void scan_windows();
	void do_event_loop();
	
	void quit_nicely();
	
	void Grab() { XGrabServer(dpy); }
	void Ungrab() { XUngrabServer(dpy); }
	
	void closeRootMenu();
	
	void doTheme(char* path);
	void setTheme(char* path) { alternateThemePath = path; }	
};

extern WindowManager *wm;

#endif
