/* buttons.c is de c-file die de buttons EN LOUTER DE BUTTONS afhandelt */
char vernietiging[10000];
#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include "common.h"
#include "player.h"
#include "queue.h"
#include "mixer.h"

void button_main_open (GtkWidget *widget, gpointer data);
void button_main_play (GtkWidget *widget, gpointer data);
void button_main_pause (GtkWidget *widget, gpointer data);
void button_main_stop (GtkWidget *widget, gpointer data);
void button_main_ffwd (GtkWidget *widget, gpointer data);
void button_main_rewind (GtkWidget *widget, gpointer data);
void button_main_scroll (GtkWidget *widget, gpointer data);
void button_main_balance (GtkWidget *widget, gpointer data);
void button_main_volume (GtkWidget *widget, gpointer data);


void button_file_ok (GtkWidget *w, GtkFileSelection *fs);
void button_file_cancel (GtkWidget *widget, gpointer data);
void file_select_destroy (GtkWidget *widget, gpointer data);

void button_list_destroy (GtkWidget *widget, gpointer data);
void button_list_add (GtkWidget *widget, gpointer data);
void button_list_shuffle (GtkWidget *widget, gpointer data);
void button_list_select (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer data);
void button_list_remove (GtkWidget *widget, gpointer data);
void button_list_unselect (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer data);

void button_main_open (GtkWidget *widget, gpointer data)
{
	gtk_widget_show (window_list);
}

void button_main_play (GtkWidget *widget, gpointer data)
{
	play_file (now_playing);	
}

void button_main_pause (GtkWidget *widget, gpointer data)
{
	pause_file ();
}
void button_main_stop (GtkWidget *widget, gpointer data)
{
	stop_file ();
}

void button_main_ffwd (GtkWidget *widget, gpointer data)
{
	ffwd_file ();
}

void button_main_rewind (GtkWidget *widget, gpointer data)
{
	rewind_file ();
}

void button_main_scroll (GtkWidget *widget, gpointer data)
{
	scroll_file (GTK_ADJUSTMENT(widget)->value);
}

void button_main_balance (GtkWidget *widget, gpointer data)
{
	set_balance (GTK_ADJUSTMENT(widget)->value);
}


void button_main_volume (GtkWidget *widget, gpointer data)
{
	set_volume (GTK_ADJUSTMENT(widget)->value);
}

/* ---=+=-<X>-=+=--=+=-<XX>-=+=--=+=-<XXX>-=+=--=+=-<XX---+---XX>-=+=--=+=-<XXX>-=+=--=+=-<XX>-=+=--=+=-<X>-=+=---*/

void button_file_ok (GtkWidget *w, GtkFileSelection *fs)
{
	FILE *TempFile;
	char oneline[4000];
	char volledige_naam[4000];
	char *dummy;

	gpointer lengte;		/* de pointer naar het eind van de string, zodat de lengte eraf kan worden getrokken */
	int vgl1, vgl2;		/* 2 vergelijkingsvariablen om het wat overzichtelijker te maken. */
	gchar *new_entry[2] = {gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)), "1"};	/* de bestandsnaam */
	strcpy (new_entry [0], gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));	/* ... ? (= copy/paste uit voorbeeld !! */
	lengte = new_entry[0] + strlen(new_entry[0]);				/* bereken de pointer naar het einde van de string */
	vgl1 = strcmp (lengte - 4 , (gpointer) ".mp3");				/* vergelijk de laatste 4 karakters met ".mp3" */
	vgl2 = strcmp (lengte - 4, (gpointer) ".MP3");				/* en ook met ".MP3" */ /* (dus niet met .Mp3 en .mP3) */
	if ( vgl1 == 0 || vgl2 == 0)						/* komt een van tweeen overeen ? */
	{
		add_item (new_entry[0]);
	}
	
	if (strcmp (lengte - 1, (gpointer) "/") == 0)				/* kijk of het een directory is */
	{
		chdir (new_entry[0]);
		system("find >/tmp/gamp.tmp");
		TempFile = fopen("/tmp/gamp.tmp","r");
		if (TempFile == NULL)
		{
			return;
		}
		do
		{
			dummy = fgets(oneline, 4000, TempFile);
			if (dummy != NULL)
			{
				oneline [strlen (oneline)-1] = 0;

				lengte = (gpointer) oneline + strlen(oneline);	/* bereken de pointer naar het einde van de string */
				vgl1 = strcmp (lengte - 4 , (gpointer) ".mp3");	/* vergelijk de laatste 4 karakters met ".mp3" */
				vgl2 = strcmp (lengte - 4, (gpointer) ".MP3");	/* en ook met ".MP3" */ /* (dus niet met .Mp3 en .mP3) */

				if ( vgl1 == 0 || vgl2 == 0)			/* komt een van tweeen overeen ? */
				{
					strcpy ((gpointer) volledige_naam, new_entry[0]);
					strcat ((gpointer) volledige_naam, &oneline[2]);
					add_item(volledige_naam);
				}
			}
		} while (dummy != NULL);
		fclose(TempFile);
	}
}

void button_file_cancel (GtkWidget *widget, gpointer data)
{
	gtk_widget_hide (window_file_select);
}

void file_select_destroy (GtkWidget *widget, gpointer data)
{
	gtk_widget_hide (window_file_select);
}
/* ---=+=-<X>-=+=--=+=-<XX>-=+=--=+=-<XXX>-=+=--=+=-<XX---+---XX>-=+=--=+=-<XXX>-=+=--=+=-<XX>-=+=--=+=-<X>-=+=---*/
void button_list_destroy (GtkWidget *widget, gpointer data)
{
	gtk_widget_hide (window_list);
}

void button_list_add (GtkWidget *widget, gpointer data)
{
	gtk_widget_show (window_file_select);
}
void button_list_shuffle (GtkWidget *widget, gpointer data)
{
	int i;
	shake_list();
	for (i=0;i<playlistlength;i++) {
		vernietiging[i] = 51; 
	}	
}
void button_list_select (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer data)
{
	if (event && (event->type == GDK_2BUTTON_PRESS))
	{
		play_file (row);
	}
	vernietiging[row] = 13; 		/* 13 is het getal van selectie */
}

void button_list_remove (GtkWidget *widget, gpointer data)
{
	int i;
	gtk_clist_freeze (GTK_CLIST(playlist));
	for (i=playlistlength;i>=0;i--)
	{
		if (vernietiging[i] == 13)
 		{
			gtk_clist_remove (GTK_CLIST(playlist), i);
			if (now_playing >= i) now_playing --;
			playlistlength --;
			vernietiging[i] = 51;
		}
	}
	gtk_clist_thaw (GTK_CLIST(playlist));
}

void button_list_unselect (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer data)
{
	vernietiging[row] = 51;		/* is zomaar een getal dat niet 13 is */
}
