#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "common.h"

struct mp3info *read_tag(char *filename);
void zoek (FILE *pijp, char *doel);
char *lees_tot (FILE *pijp, char *doel);
char *reduce_name(char *longname);

struct mp3info *read_tag(char *filename)
{
	FILE *pijp;
	char *kindnaam;
	char touw[181];

	struct mp3info *get_info;
	char *tag_frame;
	char *tag_time;

	kindnaam = (char *)malloc (sizeof(filename)+200);
	strcpy (kindnaam, (char *)"mpg123 -v -t -n1 \"");
	strcat (kindnaam, filename);
	strcat (kindnaam, (char *)"\" &>/dev/stdout");
	pijp = popen(kindnaam, "r");
	free (kindnaam);


	get_info = (struct mp3info *) malloc(sizeof(struct mp3info));

	get_info->filename = (char *)malloc (strlen(filename)+1);
	strcpy (get_info->filename,filename);
	zoek (pijp,"RISK!");
	fscanf (pijp, "%180s", touw);
	if (!strcmp (touw, (char *)"Title"))
	{
		fscanf (pijp, "%180s", touw);
		get_info->songname = lees_tot (pijp, "Artist:");
		if (strlen(get_info->songname) == 0)
		{
			free (get_info->songname);
			get_info->songname = reduce_name (get_info->filename);
		}

		get_info->artist = lees_tot (pijp, "Album");
		fscanf (pijp, "%180s", touw);

		get_info->album = lees_tot (pijp, "Year:");
		get_info->year = lees_tot (pijp, "Comment:");
		get_info->comment = lees_tot (pijp, "Genre:");
		get_info->genre = lees_tot (pijp, "Playing");
	}
	else
	{
		get_info->songname = reduce_name (get_info->filename);
		get_info->artist = (char *) 0;
		get_info->album = (char *) 0;
		get_info->year = (char *) 0;
		get_info->comment = (char *) 0;
		get_info->genre = (char *) 0;
	}
	zoek (pijp, "...");
	fscanf (pijp, "%180s", touw);
	if (!strcmp (touw, (char *) "MPEG"))
	{
		zoek (pijp, "Bitrate:");
		get_info->bitrate = lees_tot (pijp, "Kbits/s,");

		zoek (pijp, "Frame#");
		fscanf (pijp, "%180s", touw);
		tag_frame = lees_tot (pijp, "Time:");
		tag_frame[strlen(tag_frame)-2] = 0;
		strcpy (tag_frame, tag_frame+1);
		get_info->frames = atoi (tag_frame);
		free (tag_frame);

		fscanf (pijp, "%180s", touw);
		tag_time = lees_tot (pijp, "[0:00]");
		tag_time[strlen(tag_time)-2] = 0;
		strcpy (tag_time, tag_time+1);
		get_info->seconds = atof(tag_time)*60;
		strcpy (tag_time, tag_time+3);
		
		get_info->seconds = get_info->seconds + atof(tag_time); 
		free (tag_time);
	}
	else
	{
		get_info->bitrate = (char *) "0";
		get_info->frames = 0;
		get_info->seconds = 0;
	}
	pclose (pijp);
	return get_info;
}

void zoek (FILE *pijp, char *doel)
{
	char touw [181];
	while (strcmp(touw, doel))
	{
		fscanf (pijp, "%180s", touw);
	}
}

char *lees_tot (FILE *pijp, char *doel)
{
	char *terug;
	char touw [181];
	terug = ((char *) malloc(1));
	*terug = 0;
	fscanf (pijp, "%180s", touw);
	while (strcmp (touw, doel))
	{
		terug = (char *)realloc((char *)terug,strlen(terug)+strlen (touw) +2);
		strcat (terug, touw);
		fscanf (pijp, "%180s", touw);
		if (strcmp (touw,doel)) strcat (terug, " ");
	}
	return terug;
}

char *reduce_name(char *longname)
{
	int i;
	int laatste = 0;
	char *shortname;
	for(i=0;i<strlen(longname);i++)
		{
			if (longname[i] == 47) laatste = i+1;
		}
	shortname = (char *) malloc(strlen(longname));
	for (i=laatste;i<strlen(longname)-4;i++)
		shortname[i-laatste] = longname[i];
	shortname [strlen(longname) - laatste -4] = 0;
	return shortname;
}
