#include <stdio.h>
#include <gtk/gtk.h>
#include "common.h"
#include "buttons.h"
#define DATA_DIR "/usr/local/share/whamp/"

void fill_windows ();

void fill_main_window ();
void fill_list_window ();
void fill_file_select_window ();

void close_program (GtkWidget widget, gpointer data);
GtkWidget *xpm_button (GtkWidget *parent, gchar *xpm_filename);

void fill_windows ()
{
	fill_main_window ();
	fill_list_window ();
	fill_file_select_window ();
}

void fill_main_window ()
{
	GtkWidget *window_main;
	GtkWidget *vbox;
	GtkWidget *buttonbox;
	GtkWidget *button;
	GtkWidget *hscale;
	GtkWidget *scrollbox;
	GtkWidget *volumescale;
	GtkWidget *balansscale;
	GtkWidget *label;
	GtkWidget *balancebox;

	window_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_container_border_width (GTK_CONTAINER(window_main),10);
	gtk_window_set_title (GTK_WINDOW (window_main), "WHAMp 0.4");
	gtk_signal_connect (GTK_OBJECT (window_main), "destroy", GTK_SIGNAL_FUNC(close_program), NULL);

	vbox = gtk_vbox_new (TRUE, TRUE);
	gtk_widget_show (vbox);
	gtk_container_add (GTK_CONTAINER(window_main),vbox);

	/* de text-entry */	
	text_info = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX(vbox), text_info, FALSE, FALSE, 0);
	gtk_entry_set_text(GTK_ENTRY(text_info), "Not playing anything yet.");
	gtk_entry_set_editable (GTK_ENTRY(text_info), FALSE);
	gtk_widget_show (text_info);
	
	/* het scrollbalkje */
	scrollbox = gtk_hbox_new(FALSE, TRUE);
	gtk_widget_show (scrollbox);
	gtk_box_pack_start (GTK_BOX (vbox), scrollbox, FALSE, FALSE, 0);
	label = gtk_label_new("time :");
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (scrollbox), label, FALSE, FALSE, 10);
	aanpassing = gtk_adjustment_new (0,0,1,.001,.1,.001);
	hscale = gtk_hscale_new (GTK_ADJUSTMENT(aanpassing));
	gtk_widget_set_usize(GTK_WIDGET (hscale), 250,20);
	gtk_scale_set_draw_value (GTK_SCALE (hscale), FALSE);
	gtk_scale_set_digits (GTK_SCALE (hscale),3);
	gtk_box_pack_start (GTK_BOX(scrollbox),hscale, TRUE, TRUE,0);
	gtk_widget_show (hscale);
	gtk_signal_connect(GTK_OBJECT(aanpassing), "value_changed", GTK_SIGNAL_FUNC(button_main_scroll), aanpassing);
	verstreken_tijd = gtk_label_new("0:00");
	gtk_widget_show (verstreken_tijd);
	gtk_widget_set_usize (GTK_WIDGET (verstreken_tijd), 50,30);
	gtk_box_pack_start (GTK_BOX(scrollbox), verstreken_tijd, FALSE, FALSE, 0);

	/* het balansbalkje */
	balancebox = gtk_hbox_new(FALSE, FALSE);
	gtk_widget_show (balancebox);
	gtk_box_pack_start (GTK_BOX (vbox), balancebox, FALSE, FALSE, 0);

	label = gtk_label_new("Bal :");
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (balancebox), label, FALSE, FALSE, 5);


	balans = gtk_adjustment_new (0,-1,1,.1,.1,.1);
	balansscale = gtk_hscale_new (GTK_ADJUSTMENT(balans));
	gtk_widget_show (balansscale);
	gtk_signal_connect(GTK_OBJECT(balans), "value_changed", GTK_SIGNAL_FUNC(button_main_balance), balans);
	gtk_scale_set_draw_value (GTK_SCALE (balansscale), FALSE);
	gtk_scale_set_digits (GTK_SCALE (balansscale), 1);
	gtk_box_pack_start (GTK_BOX(balancebox), balansscale, TRUE, TRUE, 0);

	/* the volume bar */

	label = gtk_label_new("    Vol :");
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (balancebox), label, FALSE, FALSE, 5);


	volume = gtk_adjustment_new (1,0,1,.001,.001,.001);
	volumescale = gtk_hscale_new (GTK_ADJUSTMENT(volume));
	gtk_widget_show(volumescale);
	gtk_signal_connect(GTK_OBJECT(volume), "value_changed", GTK_SIGNAL_FUNC(button_main_volume), volume);
	gtk_scale_set_draw_value (GTK_SCALE (volumescale), FALSE);
	gtk_scale_set_digits (GTK_SCALE (volumescale), 2);
	gtk_box_pack_start (GTK_BOX(balancebox), volumescale, TRUE, TRUE, 0);



	/* de knopjes */
	buttonbox = gtk_hbox_new(FALSE,0);
	gtk_widget_show (buttonbox);
	gtk_box_pack_start (GTK_BOX(vbox), buttonbox, FALSE, FALSE, 0);
	label = gtk_label_new ("WHAMp");
	gtk_widget_show (label);
	gtk_box_pack_start(GTK_BOX(buttonbox),label, TRUE, TRUE, 0);
	button = xpm_button(buttonbox, (gchar *) DATA_DIR "rewind.xpm");
	gtk_signal_connect (GTK_OBJECT(button),"clicked", GTK_SIGNAL_FUNC(button_main_rewind), NULL);
	button = xpm_button(buttonbox, (gchar *) DATA_DIR "play.xpm");
	gtk_signal_connect (GTK_OBJECT(button),"clicked", GTK_SIGNAL_FUNC(button_main_play), NULL);
	button = xpm_button(buttonbox, (gchar *) DATA_DIR "pause.xpm");
	gtk_signal_connect (GTK_OBJECT(button),"clicked", GTK_SIGNAL_FUNC(button_main_pause), NULL);
	button = xpm_button(buttonbox, (gchar *) DATA_DIR "stop.xpm");
	gtk_signal_connect (GTK_OBJECT(button),"clicked", GTK_SIGNAL_FUNC(button_main_stop), NULL);
	button = xpm_button(buttonbox, (gchar *) DATA_DIR "ffwd.xpm");
	gtk_signal_connect (GTK_OBJECT(button),"clicked", GTK_SIGNAL_FUNC(button_main_ffwd), NULL);
	button = xpm_button(buttonbox, (gchar *) DATA_DIR "open.xpm");
	gtk_signal_connect (GTK_OBJECT(button),"clicked", GTK_SIGNAL_FUNC(button_main_open), NULL);





	gtk_widget_show(window_main);
}

void fill_list_window ()
{
	GtkWidget *main_box;
	GtkWidget *buttonbox;
	GtkWidget *button;
	GtkWidget *ScrollWindow;
	gchar     *titles[2] = {"Name", "Length"};
	
	window_list = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(GTK_WIDGET(window_list), 400,300);
	gtk_container_border_width (GTK_CONTAINER(window_list),20);
	gtk_signal_connect (GTK_OBJECT (window_list), "destroy", GTK_SIGNAL_FUNC (button_list_destroy), NULL);
	gtk_signal_connect (GTK_OBJECT (window_list), "delete_event", GTK_SIGNAL_FUNC (button_list_destroy), NULL);

	main_box = gtk_vbox_new (FALSE, FALSE);
	gtk_widget_show (main_box);
	gtk_container_add (GTK_CONTAINER(window_list),main_box);
	
	playlist = gtk_clist_new_with_titles(2, titles);
	gtk_clist_set_selection_mode (GTK_CLIST(playlist), GTK_SELECTION_EXTENDED);
	gtk_signal_connect (GTK_OBJECT(playlist), "select_row", GTK_SIGNAL_FUNC(button_list_select), NULL);
	gtk_signal_connect (GTK_OBJECT(playlist), "unselect_row", GTK_SIGNAL_FUNC(button_list_unselect), NULL);
	gtk_widget_show (playlist);
	ScrollWindow = gtk_scrolled_window_new (GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
	gtk_container_add (GTK_CONTAINER(ScrollWindow), playlist);
	gtk_widget_show (ScrollWindow);

	gtk_box_pack_start (GTK_BOX (main_box), ScrollWindow, TRUE, TRUE, 0);
	gtk_clist_set_column_width (GTK_CLIST (playlist),0,280);

	buttonbox = gtk_hbox_new(FALSE, FALSE);
	gtk_widget_show (buttonbox);
	gtk_box_pack_start (GTK_BOX(main_box), buttonbox, FALSE, FALSE, 10);
	
	button = xpm_button (buttonbox, DATA_DIR "add.xpm");
	gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (button_list_add),NULL);	
	button = xpm_button (buttonbox, DATA_DIR "remove.xpm");
	gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (button_list_remove), NULL);
	button = xpm_button (buttonbox, DATA_DIR "shuffle.xpm");
	gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (button_list_shuffle), NULL);
}

void fill_file_select_window ()
{
	window_file_select = gtk_file_selection_new ("File selection");
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(window_file_select)->ok_button), "clicked",
			GTK_SIGNAL_FUNC (button_file_ok), window_file_select);
	gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION(window_file_select)->cancel_button),"clicked",
			GTK_SIGNAL_FUNC (button_file_cancel), NULL);
	gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION(window_file_select)), "destroy",
			GTK_SIGNAL_FUNC (file_select_destroy), NULL);
	gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION(window_file_select)), "delete_event",
			GTK_SIGNAL_FUNC (file_select_destroy), NULL);
}

void close_program (GtkWidget widget, gpointer data)
{
	gtk_exit (0);
}

GtkWidget *xpm_button (GtkWidget *parent, gchar *xpm_filename)
{
	GtkWidget *knopje;
	GtkWidget *pixmapwid;
	GtkWidget *doos;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkStyle *style;


	knopje = gtk_button_new();
	gtk_widget_show (knopje);

	doos = gtk_vbox_new(TRUE, TRUE);
	gtk_widget_show (doos);
	gtk_container_border_width(GTK_CONTAINER(doos),4);

	gtk_widget_realize(parent);
	style = gtk_widget_get_style(parent);
	pixmap = gdk_pixmap_create_from_xpm (parent->window, &mask, &style->bg[GTK_STATE_NORMAL], xpm_filename);
	pixmapwid = gtk_pixmap_new (pixmap, mask);
	gtk_widget_show(pixmapwid);
	gtk_box_pack_start (GTK_BOX(doos),pixmapwid, FALSE, FALSE, 0);
	gtk_container_add (GTK_CONTAINER (knopje), doos);
	gtk_box_pack_start (GTK_BOX(parent),knopje,FALSE, FALSE,0);	
	return knopje;
}	
