#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>

double current_balance = 0;
double current_volume = 1;

void set_mixer (double volume, double balance);
void set_volume (double volume);
void set_balance (double balance);


void set_balance (double balance)
{
	current_balance = balance;
	set_mixer (current_volume, current_balance);
}	

void set_volume (double volume)
{
	current_volume = volume;
	set_mixer (current_volume, current_balance);
}	


/*    deze functie zet het volume met volume tussen de 0 en 1 en balance tussen de -1 en de 1 */

void set_mixer (double volume, double balance)
{
	int mixer_fd;
	double fin_vol_left;
	double fin_vol_right;
	int i,j;
	int fin_vol;
	mixer_fd = open ("/dev/mixer",O_RDWR,0);

	fin_vol_right = volume;
	if (balance > 0) fin_vol_right = volume - (fin_vol_right * balance);
	i = pow(fin_vol_right,.3) * 100;
	fin_vol_left = volume;
	if (balance < 0) fin_vol_left = volume + (fin_vol_left * balance);
	j = pow(fin_vol_left,.3) * 100;
	fin_vol = (j<<8)+i;
	
	printf ("%f %f %i\n",fin_vol_left, fin_vol_right, fin_vol);
	ioctl (mixer_fd, MIXER_WRITE(0), &fin_vol); /* het werkelijke volume zetten */
	close (mixer_fd);
}
