#include <gtk/gtk.h>
#include "common.h"
#include <sys/types.h>
#include <signal.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdio.h>

void play_file (int nummer);
void pause_file ();
void stop_file ();
void ffwd_file ();
void rewind_file ();
void scan_clear (gpointer data);
void execute (char **argumenten);
void scroll_file (float time);

float seconds_played;
float seconds_total;
int freeze;

void play_file (int nummer)
{
	GdkColor black;
	GdkColor red;
	struct mp3info *temp;
	char *argumenten[3];

	black.red=0;
	black.green=0;
	black.blue=0;
	red.red=65535;
	red.green=0;
	red.blue=0;

	if (play_status == PAUSED) 
	{
		pause_file();
		return;
	}
	if (playlistlength == 0) return;
	if (nummer >= playlistlength) nummer = 0;
	temp  = gtk_clist_get_row_data (GTK_CLIST(playlist), nummer);

	argumenten [0] = (char *) "mpg123";
	argumenten [1] = temp->filename;
	argumenten [2] = NULL;
	gtk_clist_set_foreground (GTK_CLIST(playlist), now_playing, &black); 
	gtk_clist_set_foreground (GTK_CLIST(playlist), nummer, &red); 
	
	now_playing = nummer;

	play_status = PLAYING;
	execute (argumenten);
	gtk_entry_set_text(GTK_ENTRY(text_info), temp->songname);
	seconds_played = 0;
	seconds_total = temp->seconds;
}

void pause_file ()
{
	if (play_status == PAUSED)
	{
		kill (pid,18);
		play_status = PLAYING;
	}
	else if (play_status == PLAYING)
	{
		kill (pid,19);	
		play_status = PAUSED;
	}
}

void stop_file ()
{
	if (play_status != STOPPED)
	{
		kill (pid,18);
		kill (pid,15);
		waitpid (pid, 0,0);
		pid = 0;
		play_status = STOPPED;
	}
}

void ffwd_file ()
{
	int volgende;
	if (play_status == PAUSED) stop_file();

	volgende = now_playing +1;
	if (volgende >= playlistlength) volgende = 0;
	play_file (volgende);
}

void rewind_file()
{
	if (play_status == PAUSED) stop_file();
	if (now_playing == 0) 
	{
		play_file (playlistlength-1);
	}
	else 
	{
		play_file (now_playing -1);
	}
}

void execute (char **argumenten)
{
	int status;
	int dummy;
	if (pid != 0)					/* als er al een kindje is */
	{
		kill (pid,18);
		kill (pid,15);				/* breng het kindje om het leven */
		dummy = waitpid(pid, &status, 0);	/* merk op dat het kindje dood is */
		pid = 0;
	}
	pid = fork();
	if (pid == 0)
	{
		execvp(*argumenten, argumenten);
		perror (*argumenten);
		exit(1);
	}
}

void scan_clear (gpointer data)
{
	int status;
	int volgende;
	int dummy;
	int dummy2;
	char tijd[10];
	if (play_status == PLAYING)
	{
		dummy = waitpid (pid, &status, WNOHANG);	/* kijk of pid al is afgelopen, maar wacht er niet op */
		if (dummy == pid)
		{
			/* er is een programma afgelopen */
			pid = 0;
			volgende = now_playing +1;
			if (volgende >= playlistlength) volgende = 0;
			play_file (volgende);
		}
		else
		{
			seconds_played = seconds_played + .5;
/*			gtk_adjustment_set_value (GTK_ADJUSTMENT(aanpassing), seconds_played/seconds_total);*/
			GTK_ADJUSTMENT(aanpassing)->value = seconds_played/seconds_total;
			freeze = 1;
			gtk_signal_emit_by_name (GTK_OBJECT (aanpassing), "changed");
			freeze = 0;
			dummy2 = seconds_played;
			sprintf ( tijd, "%i:%02i", dummy2/60, dummy2%60);
			gtk_label_set_text (GTK_LABEL(verstreken_tijd), tijd);
		}
	}
	printf (" "); /* als deze regel verwijderd wordt, werkt het niet meer. Ik weet niet waarom */
}

void scroll_file (float time)
{
	char *argumenten[5];
	struct mp3info *temp;
	int frame;
	char framestring[10];

	if (freeze == 1) return;
	temp  = gtk_clist_get_row_data (GTK_CLIST(playlist), now_playing);

	if (playlistlength == 0) return;

	temp  = gtk_clist_get_row_data (GTK_CLIST(playlist), now_playing);
	frame = (time * temp->frames);
	sprintf (framestring, "%i",frame);
	argumenten [0] = (char *) "mpg123";
	argumenten [1] = (char *) "-k";
	argumenten [2] = framestring;
	argumenten [3] = temp->filename;
	argumenten [4] = NULL;
	execute (argumenten);

	play_status = PLAYING;
	seconds_played = time * temp->seconds;
}
